jQuery( function( $ ) {
	
	let toolsForms = [ 'batch-edit', 'batch-add-product', 'batch-remove-product', 'batch-add', 'batch-edit-po', 'batch-add-po', 'batch-remove-po' ];
	
	$.each( toolsForms, function( i, form_id ) {
		$( '.wpo_wcpbn_batch_tools #button-'+form_id ).on( 'click', function() {
			let $form = $( this ).closest( '.table-wrapper' ).find( 'form#'+form_id );
			
			if ( $form.is( ':visible' ) === true ) {
				$form.hide();
			} else {
				$form.show();
			}
		} ).click();
	} );
	
	$( '.wpo_wcpbn_batch_tools .button-cancel' ).on( 'click', function( e ) {
		e.preventDefault();
		let $form = $( this ).closest( 'form' );
		
		if ( $form.is( ':visible' ) === true ) {
			$form.hide();
		}
		
		return;
	} );
	
	$( '.wpo_wcpbn_batch_tools .button-submit' ).on( 'click', function( e ) {
		e.preventDefault();
		
		let $form  = $( this ).closest( 'form' );
		let formId = $form.attr( 'id' );
		
		if ( $.inArray( formId, toolsForms ) != -1 ) {
			
			// block UI
			$form.block( {
				message: null,
				overlayCSS: {
					background: '#fff',
					opacity: 0.6,
				}
			} );
			
			$.ajax( {
				url: wpo_wcpbn.ajaxurl,
				data:  {
					'data':   $form.serialize(),
					'action': 'wpo_wcpbn_batch_tools',
					'form':   formId,
					'nonce':  wpo_wcpbn.nonce,
				},
				type: 'POST',
				cache: false,
				success: function( response ) {
					$.each( [ 'success', 'error' ], function( i, type ) {
						if ( response.data[type] ) {
							let $notice = $form.find( '.notice' );
							$notice.addClass( 'notice-'+type );
							$notice.find( 'p' ).text( response.data[type] );
							$notice.show();
						}
					} );

					// unblock UI
					$form.unblock();
					
					window.location.reload();
					return;
				},
				error: function( xhr, status, error ) {
					console.log( error );
				},
			} );
			
		}
	} );
	
	// batch search
	$( document.body ).on( 'click', '.wpo_wcpbn_settings a.batch-search-button', function( e ) {
		e.preventDefault();
		
		let search_val = $( this ).closest( 'div' ).find( ':input[name="batch_id_search_input"]' ).val();
		window.location.href = window.location.href + '&batch=' + search_val;
	} );
	
	// set MinLength when a SKU is to be searched
	let $select = $( '#search_by' );
	let $input  = $( '#wcpbn-search-input' );

	let update_input_min_length = () => {
		$input.prop( 'minLength', ( 'product_sku' === $select.val() ) ? 3 : 0 ).trigger( 'change' );
	};

	update_input_min_length();

	$select.change( function() {
		update_input_min_length();
	} );
} );