<?php
	if ( ! defined( 'ABSPATH' ) ) {
		die;
	}

	if ( empty( $batch ) ) {
		echo '<div class="notice notice-warning inline"><p>'.__( 'An error occurred. Batch not found!', 'woocommerce-product-batch-numbers' ).'</p></div>';
		return;
	}
?>
<div class="wpo_wcpbn_settings_container wpo_wcpbn_batch_tools">
	<h3>
		<span class="dashicons dashicons-admin-tools"></span>
		<?php _e( 'Tools', 'woocommerce-product-batch-numbers' ); ?>
	</h3>
	<div class="table-wrapper" style="margin-bottom:30px;">
		<p>
			<h4>
				<?php
					printf(
						/* translators: batch ID */
						__( 'Batch #%s', 'woocommerce-product-batch-numbers' ),
						$batch->id
					);
				?>
			</h4>
			<span style="margin:5px 0;">
				<a id="button-batch-edit" class="button"><?php _e( 'Edit', 'woocommerce-product-batch-numbers' ); ?></a>
			</span>
		</p>
		<p>
			<form id="batch-edit">
				<h4><?php _e( 'Edit', 'woocommerce-product-batch-numbers' ); ?></h4>
				<div class="notice inline" style="display:none;"><p></p></div>
				<fieldset>
					<label for="batch-edit-batch_number"><?php _e( 'Number', 'woocommerce-product-batch-numbers' ); ?></label>
					<input type="text" id="batch-edit-batch_number" name="batch-edit-batch_number" value="<?php echo $batch->batch_number; ?>">
				</fieldset>
				<fieldset>
					<label for="batch-edit-date_expiry"><?php echo WPO_WCPBN()->classes['settings']->options->get_batch_date_label( WPO_WCPBN()->classes['settings']->options->get_option( 'batch_date_label' ) ); ?></label>
					<input type="date" id="batch-edit-date_expiry" name="batch-edit-date_expiry" value="<?php echo ! empty( $batch_date_expiry ) ? date_i18n( 'Y-m-d', $batch_date_expiry ) : ''; ?>">
				</fieldset>
				<fieldset>
					<label for="batch-edit-quantity_available"><?php _e( 'Available', 'woocommerce-product-batch-numbers' ); ?></label>
					<input type="number" id="batch-edit-quantity_available" min="0" name="batch-edit-quantity_available" value="<?php echo wpo_wcpbn_format_stock_amount( $batch->quantity_available ); ?>">
				</fieldset>
				<?php if ( $batch_units_enabled ) : ?>
					<fieldset>
						<label for="batch-edit-units"><?php _e( 'Units', 'woocommerce-product-batch-numbers' ); ?></label>
						<input type="number" id="batch-edit-units" name="batch-edit-units" min="1" value="<?php echo ! empty( $batch->units ) ? $batch->units : 1; ?>">
					</fieldset>
				<?php endif; ?>
				<fieldset>
					<label for="batch-edit-supplier"><?php _e( 'Supplier', 'woocommerce-product-batch-numbers' ); ?></label>
					<input type="text" id="batch-edit-supplier" name="batch-edit-supplier" value="<?php echo $batch->supplier; ?>">
				</fieldset>
				<?php if ( $stock_locations_enabled ) : ?>
					<fieldset>
						<label for="batch-edit-location"><?php _e( 'Location', 'woocommerce-product-batch-numbers' ); ?></label>
						<input type="text" id="batch-edit-location" name="batch-edit-location" value="<?php echo $batch->location; ?>">
					</fieldset>
				<?php endif; ?>
				<fieldset>
					<label for="batch-edit-status"><?php _e( 'Status', 'woocommerce-product-batch-numbers' ); ?></label>
					<select id="batch-edit-status" name="batch-edit-status">
						<?php
							foreach ( $available_status as $slug => $status ) {
								$selected = $batch->status == $slug ? 'selected' : '';
								?>
								<option value="<?= $slug; ?>" <?= $selected; ?>><?php echo $status; ?></option>
								<?php
							}
						?>
					</select>
				</fieldset>
				<input type="hidden", name="batch-edit-id" value="<?= $batch->id; ?>">
				<div class="buttons">
					<a href="" class="button button-primary button-submit"><?php _e( 'Save', 'woocommerce-product-batch-numbers' ); ?></a>
					<a href="" class="button button-cancel"><?php _e( 'Cancel', 'woocommerce-product-batch-numbers' ); ?></a>
				</div>
			</form>
		</p>
		<table class="widefat">
			<thead>
				<tr>
					<th><?php _e( 'Number', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Created', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php echo WPO_WCPBN()->classes['settings']->options->get_batch_date_label( WPO_WCPBN()->classes['settings']->options->get_option( 'batch_date_label' ) ); ?></th>
					<th><?php _e( 'Initial', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Available', 'woocommerce-product-batch-numbers' ); ?></th>
					<?php if ( $batch_units_enabled ) : ?>
						<th><?php _e( 'Units', 'woocommerce-product-batch-numbers' ); ?></th>
					<?php endif; ?>
					<th><?php _e( 'Supplier', 'woocommerce-product-batch-numbers' ); ?></th>
					<?php if ( $stock_locations_enabled ) : ?>
						<th><?php _e( 'Location', 'woocommerce-product-batch-numbers' ); ?></th>
					<?php endif; ?>
					<th><?php _e( 'Status', 'woocommerce-product-batch-numbers' ); ?></th>
				</tr>
			</thead>
			<tbody>
				<tr>
					<td><?php echo $batch->batch_number; ?></td>
					<td><?php echo date_i18n( wpo_wcpbn_date_format(), $batch_date_created ); ?></td>
					<td><?php echo ! empty( $batch_date_expiry ) ? date_i18n( wpo_wcpbn_date_format(), $batch_date_expiry ) : ''; ?></td>
					<td><?php echo wpo_wcpbn_format_stock_amount( $batch->quantity ); ?></td>
					<td><?php echo wpo_wcpbn_format_stock_amount( $batch->quantity_available ); ?></td>
					<?php if ( $batch_units_enabled ) : ?>
						<td><?php echo ! empty( $batch->units ) ? $batch->units : 1; ?></td>
					<?php endif; ?>
					<td><?php echo ! empty( $batch->supplier ) ? '<a href="'.esc_url( admin_url( 'edit.php?post_type=product&page=wpo-batch-numbers&tab=overview&s=supplier:'.$batch->supplier ) ).'">'.$batch->supplier.'</a>' : ''; ?></td>
					<?php if ( $stock_locations_enabled ) : ?>
						<td><?php echo ! empty( $batch->location ) ? '<a href="'.esc_url( admin_url( 'edit.php?post_type=product&page=wpo-batch-numbers&tab=overview&s=location:'.$batch->location ) ).'">'.$batch->location.'</a>' : ''; ?></td>
					<?php endif; ?>
					<td><?php echo $available_status[$batch->status]; ?>
					</td>
				</tr>
			</tbody>
		</table>
	</div>
	<div class="table-wrapper" style="margin-bottom:30px;">
		<p>
			<h4><?php _e( 'Shared between', 'woocommerce-product-batch-numbers' ); ?></h4>
			<span style="margin:5px 0;">
				<a id="button-batch-add-product" class="button"><?php _e( 'Add product', 'woocommerce-product-batch-numbers' ); ?></a>
				<a id="button-batch-remove-product" class="button"><?php _e( 'Remove product', 'woocommerce-product-batch-numbers' ); ?></a>
			</span>
		</p>
		<p>
			<form id="batch-add-product">
				<h4><?php _e( 'Add product', 'woocommerce-product-batch-numbers' ); ?></h4>
				<div class="notice inline" style="display:none;"><p></p></div>
				<fieldset>
					<select id="batch-add-product-selected_ids" class="wc-product-search" name="batch-add-product-selected_ids[]" multiple="multiple" style="width: 400px;" data-exclude="<?php echo wc_esc_json( wp_json_encode( $all_shared_ids ) ); ?>" data-placeholder="<?php esc_attr_e( 'Search for a product&hellip;', 'woocommerce-product-batch-numbers' ); ?>" data-action="" data-allow_clear="true"></select>
				</fieldset>
				<input type="hidden", name="batch-add-product-id" value="<?php echo $batch->id; ?>">
				<div class="buttons">
					<a href="" class="button button-primary button-submit"><?php _e( 'Add', 'woocommerce-product-batch-numbers' ); ?></a>
					<a href="" class="button button-cancel"><?php _e( 'Cancel', 'woocommerce-product-batch-numbers' ); ?></a>
				</div>
			</form>
		</p>
		<p>
			<form id="batch-remove-product">
				<h4><?php _e( 'Remove product', 'woocommerce-product-batch-numbers' ); ?></h4>
				<fieldset>
					<select id="batch-remove-product-selected_ids" class="wc-product-search" name="batch-remove-product-selected_ids[]" multiple="multiple" style="width: 400px;" data-include="<?php echo wc_esc_json( wp_json_encode( $all_shared_ids ) ); ?>" data-placeholder="<?php esc_attr_e( 'Select a product&hellip;', 'woocommerce-product-batch-numbers' ); ?>" data-action="" data-allow_clear="true"></select>
				</fieldset>
				<input type="hidden" name="batch-remove-product-id" value="<?php echo $batch->id; ?>">
				<div class="buttons">
					<a href="" class="button button-primary button-submit"><?php _e( 'Remove', 'woocommerce-product-batch-numbers' ); ?></a>
					<a href="" class="button button-cancel"><?php _e( 'Cancel', 'woocommerce-product-batch-numbers' ); ?></a>
				</div>
			</form>
		</p>
		<table class="widefat">
			<thead>
				<tr>
					<th><?php _e( 'ID', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Added', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Name', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'SKU', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Managing stock?', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Status', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Stock', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Type', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Offset (in days)', 'woocommerce-product-batch-numbers' ); ?></th>
				</tr>
			</thead>
			<tbody>
				<?php
					if ( ! empty( $all_shared_ids ) ) {
						foreach ( $all_shared_ids as $pid ) {
							$product = wc_get_product( $pid );
							if ( ! empty( $product ) ) {
								$product_id     = is_callable( [ $product, 'get_parent_id' ] ) && $product->get_parent_id() != 0 ? $product->get_parent_id() : $product->get_id();
								$edit_link      = get_edit_post_link( wpo_wcpbn_wpml_object_id( $product_id ) );
								$wc_status      = wc_get_product_stock_status_options();
								$shared_product = wpo_wcpbn_get_batch_shared_product( $batch->id, $pid );
								?>
								<tr>
									<th><a href="<?php echo $edit_link; ?>"><?php echo $product->get_id(); ?></a></th>
									<th><?php echo date_i18n( wpo_wcpbn_date_format(), reset( $shared_product )->date_created ); ?></th>
									<th><?php echo $product->get_name(); ?></th>
									<th><?php echo $product->get_sku(); ?></th>
									<th><?php echo $product->managing_stock() ? __( 'Yes', 'woocommerce-product-batch-numbers' ) : __( 'No', 'woocommerce-product-batch-numbers' ); ?></th>
									<th><?php echo $wc_status[$product->get_stock_status()]; ?></th>
									<th><?php echo $product->get_stock_quantity(); ?></th>
									<th><?php echo $product->get_type(); ?></th>
									<th><?php echo wpo_wcpbn_get_product_current_offset_in_days( $pid ); ?></th>
								</tr>
								<?php
							}
						}
					} else {
						?>
						<tr><td colspan="5"><?php _e( 'No shared products.', 'woocommerce-product-batch-numbers' ); ?></td></tr>
						<?php
					}
				?>
			</tbody>
		</table>
	</div>
	<div class="table-wrapper" style="margin-bottom:30px;">
		<?php $po = wpo_wcpbn_get_batch_purchase_order( absint( $batch->id ) ); ?>
		<p>
			<h4><?php _e( 'Purchase order', 'woocommerce-product-batch-numbers' ); ?></h4>
			<span style="margin:5px 0;">
				<?php if ( ! empty( $po ) ) : ?>
					<a id="button-batch-edit-po" class="button"><?php _e( 'Edit', 'woocommerce-product-batch-numbers' ); ?></a>
					<a id="button-batch-remove-po" class="button"><?php _e( 'Remove', 'woocommerce-product-batch-numbers' ); ?></a>
				<?php else : ?>
					<a id="button-batch-add-po" class="button"><?php _e( 'Add', 'woocommerce-product-batch-numbers' ); ?></a>
				<?php endif; ?>
			</span>
		</p>
		<p>
			<?php
				$form_id    = ! empty( $po ) ? 'batch-edit-po' : 'batch-add-po';
				$form_title = ! empty( $po ) ? __( 'Edit PO', 'woocommerce-product-batch-numbers' ) : __( 'Add PO', 'woocommerce-product-batch-numbers' );
			?>
			<form id="<?php echo $form_id; ?>">
				<h4><?php echo $form_title; ?></h4>
				<div class="notice inline" style="display:none;"><p></p></div>
				<fieldset>
					<label for="<?php echo $form_id; ?>-po_number"><?php _e( 'PO number', 'woocommerce-product-batch-numbers' ); ?></label>
					<input type="text" id="<?php echo $form_id; ?>-po_number" name="<?php echo $form_id; ?>-po_number" value="<?php echo ! empty( $po ) ? $po->po_number : ''; ?>">
				</fieldset>
				<fieldset>
					<label for="<?php echo $form_id; ?>-supplier"><?php _e( 'Supplier', 'woocommerce-product-batch-numbers' ); ?></label>
					<input type="text" id="<?php echo $form_id; ?>-supplier" name="<?php echo $form_id; ?>-supplier" value="<?php echo ! empty( $po ) ? $po->supplier : ''; ?>">
				</fieldset>
				<fieldset>
					<label for="<?php echo $form_id; ?>-cost"><?php _e( 'Cost', 'woocommerce-product-batch-numbers' ); ?><?php echo ' (' . get_woocommerce_currency_symbol() . ')'; ?></label>
					<input type="text" id="<?php echo $form_id; ?>-cost" name="<?php echo $form_id; ?>-cost" value="<?php echo ! empty( $po ) ? $po->cost : ''; ?>">
				</fieldset>
				<fieldset>
					<label for="<?php echo $form_id; ?>-price_margin"><?php _e( 'Price margin', 'woocommerce-product-batch-numbers' ); ?><?php echo ' (%)'; ?></label>
					<input type="text" id="<?php echo $form_id; ?>-price_margin" name="<?php echo $form_id; ?>-price_margin" value="<?php echo ! empty( $po ) ? $po->price_margin : ''; ?>">
				</fieldset>
				<fieldset>
					<label for="<?php echo $form_id; ?>-price_discount"><?php _e( 'Price discount', 'woocommerce-product-batch-numbers' ); ?><?php echo ' (%)'; ?></label>
					<input type="text" id="<?php echo $form_id; ?>-price_discount" name="<?php echo $form_id; ?>-price_discount" value="<?php echo ! empty( $po ) ? $po->price_discount : ''; ?>">
				</fieldset>
				<?php if ( ! empty( $po ) ) : ?>
					<input type="hidden", name="<?php echo $form_id; ?>-id" value="<?php echo $po->id; ?>">
				<?php else : ?>
					<input type="hidden", name="<?php echo $form_id; ?>-batch_id" value="<?php echo $batch->id; ?>">
				<?php endif; ?>
				<div class="buttons">
					<a href="" class="button button-primary button-submit"><?php echo ! empty( $po ) ? _e( 'Save', 'woocommerce-product-batch-numbers' ) : _e( 'Add', 'woocommerce-product-batch-numbers' ); ?></a>
					<a href="" class="button button-cancel"><?php _e( 'Cancel', 'woocommerce-product-batch-numbers' ); ?></a>
				</div>
			</form>	
			<?php if ( ! empty( $po ) ) : ?>
				<form id="batch-remove-po">
					<h4><?php _e( 'Remove purchase order', 'woocommerce-product-batch-numbers' ); ?></h4>
					<p><?php printf(
						/* translators: po number */
						__( 'You are about to remove the purchase order %s from this batch. This action is irreversible.', 'woocommerce-product-batch-numbers' ),
						'<code>' . esc_attr( $po->po_number ) . '</code>'
					) ?></p>
					<input type="hidden", name="batch-remove-po-id" value="<?php echo $po->id; ?>">
					<div class="buttons">
						<a href="" class="button button-primary button-submit"><?php _e( 'Remove', 'woocommerce-product-batch-numbers' ); ?></a>
						<a href="" class="button button-cancel"><?php _e( 'Cancel', 'woocommerce-product-batch-numbers' ); ?></a>
					</div>
				</form>
			<?php endif; ?>
		</p>
		<table class="widefat">
			<thead>
				<tr>
					<th><?php _e( 'PO number', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Supplier', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Cost', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Regular price', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Sale price', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Price margin', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Price discount', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Profit', 'woocommerce-product-batch-numbers' ); ?></th>
				</tr>
			</thead>
			<tbody>
				<?php
					if ( ! empty( $po ) ) {
						?>
						<th><?php echo ! empty( $po->po_number ) ? sanitize_text_field( $po->po_number ) : ''; ?></th>
						<th><?php echo ! empty( $po->supplier ) ? sanitize_text_field( $po->supplier ) : ''; ?></th>
						<th><?php echo ! empty( floatval( $po->cost ) ) ? wc_price( $po->cost ) . ' ' . __( '(ex. tax)', 'woocommerce-product-batch-numbers' ) : ''; ?></th>
						<th><?php echo ! empty( floatval( $po->regular_price ) ) ? wc_price( $po->regular_price ) . ' ' . __( '(ex. tax)', 'woocommerce-product-batch-numbers' ) : ''; ?></th>
						<th><?php echo ! empty( floatval( $po->sale_price ) ) ? wc_price( $po->sale_price ) . ' ' . __( '(ex. tax)', 'woocommerce-product-batch-numbers' ) : ''; ?></th>
						<th><?php echo ! empty( $po->price_margin ) ? wc_format_decimal( $po->price_margin, '', true ) . '%' : ''; ?></th>
						<th><?php echo ! empty( $po->price_discount ) ? wc_format_decimal( $po->price_discount, '', true ) . '%' : ''; ?></th>
						<th>
							<?php
								if ( ! empty( floatval( $po->cost ) ) ) {
									if ( ! empty( floatval( $po->sale_price ) ) ) {
										echo wc_price( $po->sale_price - $po->cost ) . ' ' . __( '(ex. tax)', 'woocommerce-product-batch-numbers' );
									} elseif ( ! empty( floatval( $po->regular_price ) ) ) {
										echo wc_price( $po->regular_price - $po->cost ) . ' ' . __( '(ex. tax)', 'woocommerce-product-batch-numbers' );
									}
								}
							?>
						</th>
						<?php
					} else {
						?>
						<tr><td colspan="4"><?php _e( 'No purchase order found.', 'woocommerce-product-batch-numbers' ); ?></td></tr>
						<?php
					}
				?>
			</tbody>
		</table>
	</div>
	<div class="table-wrapper" style="margin-bottom:30px;">
		<p>
			<h4><?php _e( 'Consumed', 'woocommerce-product-batch-numbers' ); ?></h4>
		</p>
		<table class="widefat">
			<thead>
				<tr>
					<th><?php _e( 'Order ID', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Order status', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Product', 'woocommerce-product-batch-numbers' ); ?></th>
					<th><?php _e( 'Quantity', 'woocommerce-product-batch-numbers' ); ?></th>
				</tr>
			</thead>
			<tbody>
				<?php
					if ( ! empty( $batch->order_ids ) ) {
						$order_ids = json_decode( $batch->order_ids );
						rsort( $order_ids );
						foreach ( $order_ids as $order_id ) {
							$excluded_statuses = apply_filters( 'wpo_wcpbn_consumed_excluded_statuses', array( 'trash' ) );
							$order             = wc_get_order( $order_id );
							if ( ! empty( $order ) && ! in_array( $order->get_status(), $excluded_statuses ) ) {
								?>
								<tr>
									<td><a href="<?php echo esc_url_raw( admin_url( 'post.php?post='.$order->get_id().'&action=edit' ) ); ?>"><?php echo $order->get_id(); ?></a></td>
									<td>
										<?php
										$woo_statuses = wc_get_order_statuses();
										$statuses     = array_map( function( $status ) {
											return 'wc-' . $status;
										}, WPO_WCPBN()->classes['order_items']->get_allowed_stock_order_status( 'reduce' ) );
										$statuses     = array_intersect_key( $woo_statuses, array_flip( $statuses ) );

										echo $statuses[ 'wc-' . $order->get_status() ];
										?>
									</td>
									<td>
										<?php
											foreach ( $order->get_items() as $item ) {
												$item_batches = $item->get_meta( '_wcpbn_data' );
												if ( ! empty( $item_batches ) ) {
													foreach ( $item_batches as $item_batch ) {
														if ( $item_batch['id'] == $batch->id ) {
															$item_product = $item->get_product();
															if ( ! empty( $item_product ) ) {
																echo $item_product->get_formatted_name();
															}
														}
													}
												}
											}
										?>
									</td>
									<td>
										<?php
											foreach ( $order->get_items() as $item ) {
												$item_batches = $item->get_meta( '_wcpbn_data' );
												if ( ! empty( $item_batches ) ) {
													foreach ( $item_batches as $item_batch ) {
														if ( $item_batch['id'] == $batch->id ) {
															echo $item_batch['quantity_sold'];
														}
													}
												}
											}
										?>
									</td>
								</tr>
								<?php
							}
						}
					} else {
						?>
						<tr><td colspan="4"><?php _e( 'No consumption registries found.', 'woocommerce-product-batch-numbers' ); ?></td></tr>
						<?php
					}
				?>
			</tbody>
		</table>
	</div>
</div>