<div class="options_group">
	<div class="wpo-wcpbn-group">
		<div class="wpo-wcpbn-wrapper">
			<h4><?php _e( 'Batch Numbers', 'woocommerce-product-batch-numbers' ); ?></h4>
			<table class="wpo-wcpbn-table widefat" data-product_id="<?= isset( $product_id ) ? $product_id : null; ?>">
				<thead>
					<tr>
						<?php $colspan = 0; ?>
						<th><?php echo WPO_WCPBN()->classes['settings']->options->get_batch_date_label( WPO_WCPBN()->classes['settings']->options->get_option( 'batch_date_label' ) ); ?></th>
						<th><?php _e( 'Batch', 'woocommerce-product-batch-numbers' ); ?></th>
						<th><?php _e( 'Supplier', 'woocommerce-product-batch-numbers' ); ?></th>
						<?php if ( $stock_locations_enabled ) : ?>
							<?php $colspan++; ?>
							<th><?php _e( 'Location', 'woocommerce-product-batch-numbers' ); ?></th>
						<?php endif; ?>
						<th><?php _e( 'Quantity', 'woocommerce-product-batch-numbers' ); ?></th>
						<?php if ( $batch_units_enabled ) : ?>
							<?php $colspan++; ?>
							<th><?php _e( 'Units', 'woocommerce-product-batch-numbers' ); ?></th>
						<?php endif; ?>
						<th colspan="3"><?php _e('Status', 'woocommerce-product-batch-numbers' ); ?></th>
					</tr>
				</thead>
				<!-- WPML compatibility -->
				<?php
					global $post;
					if ( class_exists( 'Sitepress' ) && $post->ID != $product_id ) :
				?>
					<tbody>
						<td colspan="5" style="background-color:#f0f0f1;"><span class="dashicons dashicons-lock"></span> <?php _e( 'This table is locked for editing because WPML will copy its values from the original language.', 'woocommerce-product-batch-numbers' ); ?></td>
					</tbody>
				<?php else : ?>
					<tbody class="wpo-wcpbn-table-body">
						<?php
							if ( ! empty( $product_batch_numbers ) ) :
								foreach ( $product_batch_numbers as $batch ) :
									$current_status = $batch->quantity_available != $batch->quantity ? 'disabled' : null;
									$location       = ! empty( $batch->location ) ? $batch->location : '';
						?>
									<tr>
										<td class="column-expirydate">
											<input type="hidden" name="wpo-wcpbn-batch-number-id[<?= ! empty( $variation_id ) ? $variation_id : $product_id; ?>][]" value="<?= $batch->id; ?>">
											<input type="date" name="wpo-wcpbn-table-expirydate[<?= $batch->id; ?>]" value="<?= ( $batch->date_expiry == '0000-00-00 00:00:00' || $batch->date_expiry == '1000-01-01 00:00:00' ) ? null : date( 'Y-m-d', strtotime( $batch->date_expiry ) ); ?>" <?= ( $batch->date_expiry != '1000-01-01 00:00:00' && $batch->date_expiry != '0000-00-00 00:00:00' ) && ( strtotime( $batch->date_expiry ) < time() ) ? 'style="background-color: #fbeaea;"' : ( ( $batch->date_expiry == '1000-01-01 00:00:00' || $batch->date_expiry == '1000-01-01 00:00:00' ) ? null : 'style="background-color: #ecf7ed;"' ) ; ?> <?= $current_status; ?>>
										</td>
										<td class="column-batchnumber"><input class="wpo-wcpbn-table-batchnumber" type="text" name="wpo-wcpbn-table-batchnumber[<?= $batch->id; ?>]" value="<?= $batch->batch_number; ?>" placeholder="<?= __( 'Batch number', 'woocommerce-product-batch-numbers' ); ?>" <?= $current_status; ?>></td>
										<td class="column-supplier"><input class="wpo-wcpbn-table-supplier" type="text" name="wpo-wcpbn-table-supplier[<?= $batch->id; ?>]" value="<?= $batch->supplier; ?>" placeholder="<?= __( 'Supplier', 'woocommerce-product-batch-numbers' ); ?>" <?= $current_status; ?>></td>
										<?php if ( $stock_locations_enabled ) : ?>
											<td class="column-location"><input class="wpo-wcpbn-table-location" type="text" name="wpo-wcpbn-table-location[<?= $batch->id; ?>]" value="<?= $location; ?>" placeholder="<?= __( 'Location', 'woocommerce-product-batch-numbers' ); ?>" <?= $current_status; ?>></td>
										<?php endif; ?>
										<td class="column-quantities">
											<?php if ( $batch->quantity_available == $batch->quantity && $current_status != 'disabled' ) : ?>
												<input type="number" name="wpo-wcpbn-table-quantity[<?= $batch->id; ?>]" min="0" value="<?= wpo_wcpbn_format_stock_amount( $batch->quantity ); ?>" placeholder="<?= __( 'Quantity', 'woocommerce-product-batch-numbers' ); ?>" required>
											<?php else : ?>
												<div class="wpo-wcpbn-show-quantities">
													<div class="split-quantities">
														<label><?= __('Initial', 'woocommerce-product-batch-numbers'); ?></label>
														<span><?= wpo_wcpbn_format_stock_amount( $batch->quantity ); ?></span>
													</div>
													<div class="split-quantities">
														<label><?= __('Available', 'woocommerce-product-batch-numbers'); ?></label>
														<span><?= wpo_wcpbn_format_stock_amount( $batch->quantity_available ); ?></span>
													</div>
												</div>
												<div class="wpo-wcpbn-edit-quantity" style="display:none;">
													<div class="split-input">
														<label><?= __('Initial', 'woocommerce-product-batch-numbers'); ?></label>
														<input class="wpo-wcpbn-initial-quantity" value="<?= wpo_wcpbn_format_stock_amount( $batch->quantity ); ?>">
													</div>
													<div class="split-input">
														<label><?= __('Available', 'woocommerce-product-batch-numbers'); ?></label>
														<input name="wpo-wcpbn-table-quantity-available[<?= $batch->id; ?>]" value="<?= wpo_wcpbn_format_stock_amount( $batch->quantity_available ); ?>" required>
													</div>
												</div>
											<?php endif; ?>
										</td>
										<?php if ( $batch_units_enabled ) : ?>
											<td class="column-units"><input class="wpo-wcpbn-table-units" type="number" name="wpo-wcpbn-table-units[<?= $batch->id; ?>]" min="1" value="<?= isset( $batch->units ) ? absint( $batch->units ) : 1; ?>" <?= $current_status; ?> required></td>
										<?php endif; ?>
										<td class="column-status" colspan="2">
											<?php
												if ( isset( $product_status ) ) {
													echo '<select name="wpo-wcpbn-table-status['.$batch->id.']" class="'.$batch->status.'" '.$current_status.'>';
													foreach ( $product_status as $slug => $name ) {
														if ( $batch->quantity_available == 0 && $batch->status == 'archived' && $slug === 'active' ) {
															// Don't show active status
														} elseif ( $slug === $batch->status ) {
															echo '<option value="'.$slug.'" selected>'.$name.'</option>';
														} else {
															echo '<option value="'.$slug.'">'.$name.'</option>';
														}
													}
													echo '</select>';
												}
											?>
										</td>
										<td class="column-actions">
											<?php if ( $batch->quantity_available != $batch->quantity ) : ?>
												<a class="wpo-wcpbn-table-edit-row" title="<?= __( 'Edit', 'woocommerce-product-batch-numbers' ); ?>" style="cursor:pointer;"><span class="dashicons dashicons-edit"></span></a>
											<?php endif; ?>
											<a href="<?php echo admin_url( 'edit.php?post_type=product&page=wpo-batch-numbers&tab=tools&batch='.$batch->id ); ?>" target="_blank" class="wpo-wcpbn-table-tools-row" title="<?= __( 'Batch tools', 'woocommerce-product-batch-numbers' ); ?>" style="cursor:pointer;"><span class="dashicons dashicons-admin-tools"></span></a>
											<a <?= $current_status != 'disabled' ? 'style="cursor:pointer;"' : 'style="display:none;"'; ?> title="<?= __( 'Delete', 'woocommerce-product-batch-numbers' ); ?>" class="wpo-wcpbn-table-delete-row wpo-wcpbn-table-delete-db-button-<?= isset( $variation ) ? 'variation' : 'simple'; ?>" data-id="<?= $batch->id; ?>" data-pid="<?= ! empty( $variation_id ) ? $variation_id : $product_id; ?>"><span class="dashicons dashicons-trash"></span></a>
										</td>
									</tr>
						<?php
								endforeach;
							else :
						?>
							<tr>
								<?php /* translators: variation/product */ ?>
								<td colspan="5" class="wpo-wcpbn-table-empty-warning"><span class="dashicons dashicons-warning"></span> <?php printf( __( "This %s doesn't have any batch number yet.", 'woocommerce-product-batch-numbers' ), isset( $variation ) ? __( 'variation', 'woocommerce-product-batch-numbers' ) : __( 'product', 'woocommerce-product-batch-numbers' )  ); ?></td>
							</tr>
						<?php
							endif;
						?>
					</tbody>
					<tfoot>
						<tr>
							<?php
								$id     = ! empty( $variation_id ) ? $variation_id : $product_id;
								$offset = wpo_wcpbn_get_product_current_offset_in_days( $id );
							?>
							<td colspan="<?= 5 + $colspan; ?>">
								<a class="wpo-wcpbn-table-new-row-<?= isset( $variation ) ? 'variation' : 'simple'; ?> button"><?php _e( 'Add new', 'woocommerce-product-batch-numbers' ); ?></a>
								<?php if ( isset( $product_batch_numbers ) && ! empty( $product_batch_numbers ) ) : ?>
								<a class="wpo-wcpbn-table-more-of-last-<?= isset( $variation ) ? 'variation' : 'simple'; ?> button"><?php _e( 'Duplicate the last', 'woocommerce-product-batch-numbers' ); ?></a>
								<?php endif; ?>
								<?php if( ! isset( $variation ) ) : ?>
									<a class="wpo-wcpbn-table-save-data button button-primary"><?php _e( 'Save', 'woocommerce-product-batch-numbers' ); ?></a>
								<?php endif; ?>
							</td>
							<td colspan="2" class="wpo-wcpbn-product-offset">
								<span><?php _e( 'Offset (days)', 'woocommerce-product-batch-numbers' ); ?>:</span>
								<input name="wpo-wcpbn-notification-offset" class="small wpo-wcpbn-input-small" type="number" min="0" value="<?= ! empty( $offset ) ? $offset : null; ?>" title="<?php __( 'Days before expiry to trigger email notification.', 'woocommerce-product-batch-numbers' ); ?>">
								<br />
								<a href="https://docs.wpovernight.com/woocommerce-batch-numbers/how-global-and-product-offset-works/" target="_blank"><?php _e( 'How global and product offset work?', 'woocommerce-product-batch-numbers' ); ?></a>
							</td>
						</tr>
					</tfoot>
				<?php endif; ?>
			</table>
		</div>
	</div>
</div>