<?php

namespace WPO\WC\Product_Batch_Numbers;

if ( ! defined( 'ABSPATH' ) ) {
	die;
}

if ( ! class_exists( 'wcpbnCart' ) ) {

	class wcpbnCart {

		protected static $_instance = null;

		/**
		 * Instance
		 */
		public static function instance() {
			if ( is_null( self::$_instance ) ) {
				self::$_instance = new self();
			}
			return self::$_instance;
		}

		/**
		 * Construct
		 */
		public function __construct() {
			if ( ! empty( WPO_WCPBN()->classes['settings']->options->get_option( 'display_batch_data_in_cart' ) ) && WPO_WCPBN()->classes['settings']->options->get_option( 'display_batch_data_in_cart' ) != 'no' ) {
				add_action( 'woocommerce_after_cart_item_name', array( $this, 'display_batch_data_in_cart' ), 99, 2 );
			}
		}

		public function display_batch_data_in_cart( $cart_item, $cart_item_key ) {
			if ( empty( $cart_item ) ) {
				return;
			}

			$product_id  = 0 != $cart_item['variation_id'] ? $cart_item['variation_id'] : $cart_item['product_id'];
			$data_format = WPO_WCPBN()->classes['settings']->options->get_option( 'display_batch_data_in_cart' );
			$batches     = wpo_wcpbn_allocate_batch_numbers( $product_id, $cart_item['quantity'] );

			wpo_wcpbn_print_product_batch_data_formatted( $product_id, $data_format, true, true, '', '', '', $batches );
		}

	}

}