<?php

namespace WPO\WC\Product_Batch_Numbers;

if ( ! defined( 'ABSPATH' ) ) {
	die;
}

if ( ! class_exists( 'wcpbnLogger' ) ) {

	class wcpbnLogger {

		public           $wc_logger;
		public           $context    = array( 'source' => 'wpo-wcpbn' );
		public           $levels     = array( 'debug', 'info', 'notice', 'warning', 'error', 'critical', 'alert', 'emergency' );
		protected static $_instance  = null;

		/**
		 * Logger instance
		 */
		public static function instance() {
			if ( is_null( self::$_instance ) ) {
				self::$_instance = new self();
			}
			return self::$_instance;
		}

		/**
		 * Construct
		 */
		public function __construct() {
			$this->wc_logger = wc_get_logger();
		}

		/**
		 * Logs a message
		 *
		 * @param  string  $message  The message
		 * @param  string  $level    The log level: 'debug', 'info', 'notice', 'warning', 'error', 'critical', 'alert', 'emergency'
		 * 
		 * @return void
		 */
		public function log( $message, $level = 'error' ) {
			if ( empty( $message ) || ! in_array( $level, $this->levels ) ) return;
			$this->wc_logger->log( $level, $message, $this->context );
		}

	}

}