<?php
/**
 * Search Class
 *
 * @since 1.0.0
 */

namespace WPO\WC\Product_Batch_Numbers;

/**
 * If this file is called directly, abort.
 *
 * @since 1.0.0
 */
if ( ! defined( 'ABSPATH' ) ) {
	die;
}

if ( ! class_exists( 'wcpbnSearch' ) ) {

	class wcpbnSearch {

		protected static $_instance = null;

		/**
		 * Instance
		 */
		public static function instance() {
			if ( is_null( self::$_instance ) ) {
				self::$_instance = new self();
			}
			return self::$_instance;
		}

		/**
		 * Construct
		 */
		public function __construct() {
			add_filter( 'woocommerce_shop_order_search_results', array( $this, 'search_orders_by_batch_id' ), 15, 3 );
		}

		/**
		 * Search orders by batch number.
		 *
		 * @return array
		 */
		public function search_orders_by_batch_id( $order_ids = array(), $batch_id = '', $search_fields = null ) {
			if ( ! empty( $batch_id ) ) {
				$results = wpo_wcpbn_get_batch_order_ids( $batch_id );
				if ( ! empty( $results ) ) {
					$order_ids_found = json_decode( $results[0]->order_ids );
					if ( is_array( $order_ids_found ) ) {
						$order_ids = array_merge( $order_ids, $order_ids_found );
					}
				}
			}

			return $order_ids;
		}

	}

}