<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * DEPRECATED: Inserts a new batch.
 *
 * @return void
 */
function wpo_wcpbn_add_new_batch( $product_id, $variation_id = null, $date_expiry = null, $batch_number = null, $supplier = null, $quantity = null, $quantity_available = null, $status = null, $batch_id = null ) {
	wc_deprecated_function( 'wpo_wcpbn_add_new_batch', '1.9.0', 'wpo_wcpbn_insert_batch' );
	
	if ( empty( $product_id ) || empty( $batch_number ) || empty( $quantity ) || $quantity < 0 ) {
		return;
	}

	$data = array(
		'date_created'       => date( 'Y-m-d H:i:s' ),
		'user_id'            => get_current_user_id(),
		'product_ids'        => [ intval( $product_id ) ],
		'batch_number'       => $batch_number,
		'quantity'           => wpo_wcpbn_force_stock_amount_type( $quantity ),
		'quantity_available' => wpo_wcpbn_force_stock_amount_type( $quantity ),
		'status'             => 'active'
	);

	if ( ! is_null( $date_expiry ) ) {
		$data['date_expiry'] = $date_expiry;
	}
	if ( ! is_null( $variation_id ) ) {
		$data['variation_id'] = $variation_id;
	}
	if ( ! is_null( $supplier ) ) {
		$data['supplier'] = $supplier;
	}
	if ( ! is_null( $quantity_available ) ) {
		$data['quantity_available'] = wpo_wcpbn_force_stock_amount_type( $quantity_available );
	}
	if ( ! is_null( $status ) && in_array( $status, array( 'active', 'archived' ) ) ) {
		$data['status'] = $status;
	}
	if ( ! is_null( $batch_id ) && empty( wpo_wcpbn_get_batches( array( 'id' => $batch_id ) ) ) ) {
		$data['id'] = $batch_id;
	}

	WPO_WCPBN()->classes['database']->batch_numbers()->insert_row( $data );
}

/**
 * DEPRECATED: Get product batches.
 *
 * @return array
 */
function wpo_wcpbn_get_product_batches( $product_id, $orderby = null, $order = null ) {
	wc_deprecated_function( 'wpo_wcpbn_get_product_batches', '1.5.1', 'wpo_wcpbn_get_batches' );

	if ( empty( $product_id ) ) {
		return array();
	}

	$query_args = array(
		'product_ids' => [ intval( $product_id ) ],
		'status'      => 'active',
		'order_by'    => $orderby,
		'order'       => $order,
	);
	$batches = wpo_wcpbn_get_batches( $query_args );

	if ( empty( $batches ) ) {
		return array();
	}

	return $batches;
}

/**
 * DEPRECATED: Get orders IDs by batch by ID.
 *
 * @return void|array
 */
function wpo_wcpbn_get_order_ids_by_batch_id( $batch_id ) {
	wc_deprecated_function( 'wpo_wcpbn_get_order_ids_by_batch_id', '1.9.0', 'wpo_wcpbn_get_batch_order_ids' );
	
	if ( empty( $batch_id ) ) {
		return;
	}

	// Get active batches
	$order_ids = WPO_WCPBN()->classes['database']->batch_numbers()->get_batch_order_ids( $batch_id );

	if ( empty( $order_ids ) ) {
		return;
	}

	$order_ids = json_decode( $order_ids[0]->order_ids );

	return $order_ids;
}

/**
 * DEPRECATED: Get batch by id.
 *
 * @return void|array
 */
function wpo_wcpbn_get_batch_by_id( $batch_id ) {
	wc_deprecated_function( 'wpo_wcpbn_get_batch_by_id', '1.5.1', 'wpo_wcpbn_get_batches' );

	if ( empty( $batch_id ) ) {
		return;
	}

	$batch = wpo_wcpbn_get_batches( array( 'id' => $batch_id ) );

	if ( empty( $batch ) ) {
		return;
	}

	return $batch;
}